# JORD ROS

## Requirements

1. This code is based on C++17, so we have to install a compiler that supports this version (We tested with g++ 12).
2. Point Cloud Library(PCL) is required for reading pcd files.
3. cmake version >= 3.0
4. ROS is installed.
   > jord_ros supports ROS1 only.

We tested ROS1 (neotic) on Ubuntu 20.04 to make sure it worked.

## Compile 

Open a terminal and type the following command
``` sh
cd /path/to/jord_ros/

source /opt/ros/<dist>/setup.bash

mkdir build && cd build

cmake ..

make
```

## Usage

jord_ros can convert the JORD dataset into a bag , or play it directly.

### Convert the JORD dataset into a bag

``` sh
cd /path/to/jord_ros/build
./jord_ros write-bag <path to JORD Dataset> <output filename> [-u|--uncompress]

```

The -u or --uncompress option sets the type of image data written to the bag. If -u or --uncompress is set, the image data will be written as sensor_msgs::Image, otherwise it will be written as sensor_msgs::CompressedImage to save disk space.

### play

``` sh
cd /path/to/jord_ros/build
./jord_ros play <path to JORD Dataset> [--speed|-s speed]

```

The --speed or -s option sets the playback speed, just like -r in the rosbag play command.

#### topic 

jord_play output topic looks similar to the following:

```

/jord/lidar1
/jord/npos220s/imu
/jord/npos220s/odometry
/jord/camera1

...
```

> In ROS1, because jord_ros play needs to publish messages, a roscore needs to be started 

We can search for and modify "/jord/npos220s/imu" in the source code and /jord/npos220s/odometry" to modify the topic value of IMU messages and Odometry messages.

For the topic of the camera's Image message and the topic of the LiDAR PointCloud2 message, we can modify the constructor in the jord_lidar_source class or jord_camera_source class in the source code.

